Attribute VB_Name = "modMain"
Option Explicit

' bentigte API-Deklarationen

Private Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" _
        (lpVersionInformation As OSVERSIONINFO) As Long

' Typendefinition Betriebssystem ermitteln:
Private Type OSVERSIONINFO
  dwOSVersionInfoSize As Long
  dwMajorVersion As Long
  dwMinorVersion As Long
  dwBuildNumber As Long
  dwPlatformId As Long
  szCSDVersion As String * 128
End Type
Private Const VER_PLATFORM_WIN32s = 0
Private Const VER_PLATFORM_WIN32_WINDOWS = 1
Private Const VER_PLATFORM_WIN32_NT = 2
Public Enum SystemTyp
  osUnknown = 0
  osWin95 = 1
  osWin98 = 2
  osWinNT = 3
  osWin2K = 4
  osWinXP = 5
  osVista = 6
  osSeven = 7
End Enum
' Ende Betriebssystem ermitteln

Public winVersion As SystemTyp  ' Kennzahl des Betriebssystems

' Prft auf NT-Betriebssysteme:
' True bei NT/2000/XP..., sonst False
Private Function isSystemNT() As Boolean
  Dim info As OSVERSIONINFO

  info.dwOSVersionInfoSize = Len(info)
  GetVersionEx info
  isSystemNT = (info.dwPlatformId = VER_PLATFORM_WIN32_NT)
End Function

Public Sub initSystem()
  Dim verInfo As OSVERSIONINFO
  
  ' Betriebssystem ermitteln:
  If isSystemNT Then
    verInfo.dwOSVersionInfoSize = Len(verInfo)
    GetVersionEx verInfo
    Select Case verInfo.dwMajorVersion
      Case 4
        winVersion = osWinNT
      Case 5
        If verInfo.dwMinorVersion Then
          winVersion = osWinXP
        Else
          winVersion = osWin2K
        End If
      Case 6
        winVersion = osVista
      Case 7
        winVersion = osSeven
      Case Else
        winVersion = osUnknown
    End Select
  Else
    winVersion = osWin98
  End If
End Sub

